# -*- coding: iso-8859-1 -*-
"""
bung zu Schtzern.  Hier ist einerseits ein ML-Schtzer (estML),
andererseits ein ELE-Schtzer (estELE).

Vgl. Skript: "Schtztheorie I"
"""

import operator


# Hilfsfunktionen
def faculty(n):
	return reduce(operator.mul, range(1, n+1), 1)

def binomial(up, down):
	return faculty(up)/(faculty(down)*faculty(up-down))

def getBinomialDist(p, n):
	return map(lambda a, p=p, n=n:binomial(n,a)*p**a*(1-p)**(n-a), range(n+1))

def sum(seq):
	return reduce(operator.add, seq, 0)

# Hier gehts los

def estELE(n, N, B):
	return (n+0.5)/(N+0.5*B)

def estML(n, N, B=0):
	return n/float(N)

def computeBiases(estimator, totalDrawn):
	for p in [n/10. for n in range(1, 10)]:
		gd = getBinomialDist(p, totalDrawn)
		print p, sum([estimator(n, totalDrawn, 2)*gd[n] 
			for n in range(totalDrawn+1)])-p

def compareEstimators(totalDrawn):
	for n in range(totalDrawn+1):
		print estELE(n, totalDrawn, 2), estML(n, totalDrawn)

def realExperiment(totalDrawn):
	import random
	while 1:
		p = random.random()
		succs = 0
		for i in xrange(totalDrawn):
			if random.random()<p:
				succs += 1
		print "p_true=%f    p_ML=%f     p_ELE=%f"%(p,
			estML(succs, totalDrawn), estELE(succs, totalDrawn, 2))
		doStop = raw_input("Enter to continue, stuff to stop? ")
		if doStop.strip():
			break

if __name__=="__main__":
	#compareEstimators(20)
	#computeBiases(estimator=estELE, totalDrawn=30)
	realExperiment(40)
